# Swagger\Client\JobsApi

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getJobs**](JobsApi.md#getjobs) | **GET** /jobs | /jobs
[**postJob**](JobsApi.md#postjob) | **POST** /jobs | /jobs

# **getJobs**
> \Swagger\Client\Model\Jobs getJobs($object_limit, $object_offset, $filter_same_account, $filter_title, $filter_status, $filter_date_from, $filter_date_to, $filter_date_until_from, $filter_date_until_to, $filter_cost_center, $sort_field, $sort_order)

/jobs

Description: Resource to obtain a list of fax jobs

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$object_limit = 100; // int | Query parameter to change de default limitation of objects in the result data array
$object_offset = 0; // int | Query parameter to change de default offset of objects in the result data array
$filter_same_account = false; // bool | Query parameter to fetch jobs after the api account linked to the used token/key for authorization
$filter_title = "filter_title_example"; // string | Query parameter to fetch jobs after his title
$filter_status = "filter_status_example"; // string | Query parameter to fetch jobs after his status
$filter_date_from = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Query parameter to fetch jobs with a later date in TimeToSend. Can be combined with filterDateTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like '2022-01-01T10:00:00+01:00'. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00)
$filter_date_to = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Query parameter to fetch jobs with a previous date in TimeToSend. Can be combined with filterDateFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like '2022-01-01T10:00:00+02:00'. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00
$filter_date_until_from = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Query parameter to fetch jobs with a later date in TimeToSendUntil. Can be combined with filterDateUntilTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like '2022-01-01T10:00:00+01:00'. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00)
$filter_date_until_to = new \DateTime("2013-10-20T19:20:30+01:00"); // \DateTime | Query parameter to fetch jobs with a previous date in TimeToSendUntil. Can be combined with filterDateUIntilFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like '2022-01-01T10:00:00+02:00'. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00
$filter_cost_center = "filter_cost_center_example"; // string | Query parameter to fetch jobs after his cost center
$sort_field = "sort_field_example"; // string | Available sort options for the result data array.
$sort_order = "asc"; // string | Describes the order for used sort fields

try {
    $result = $apiInstance->getJobs($object_limit, $object_offset, $filter_same_account, $filter_title, $filter_status, $filter_date_from, $filter_date_to, $filter_date_until_from, $filter_date_until_to, $filter_cost_center, $sort_field, $sort_order);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobsApi->getJobs: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **object_limit** | **int**| Query parameter to change de default limitation of objects in the result data array | [optional] [default to 100]
 **object_offset** | **int**| Query parameter to change de default offset of objects in the result data array | [optional] [default to 0]
 **filter_same_account** | **bool**| Query parameter to fetch jobs after the api account linked to the used token/key for authorization | [optional] [default to false]
 **filter_title** | **string**| Query parameter to fetch jobs after his title | [optional]
 **filter_status** | **string**| Query parameter to fetch jobs after his status | [optional]
 **filter_date_from** | **\DateTime**| Query parameter to fetch jobs with a later date in TimeToSend. Can be combined with filterDateTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00) | [optional]
 **filter_date_to** | **\DateTime**| Query parameter to fetch jobs with a previous date in TimeToSend. Can be combined with filterDateFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00 | [optional]
 **filter_date_until_from** | **\DateTime**| Query parameter to fetch jobs with a later date in TimeToSendUntil. Can be combined with filterDateUntilTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00) | [optional]
 **filter_date_until_to** | **\DateTime**| Query parameter to fetch jobs with a previous date in TimeToSendUntil. Can be combined with filterDateUIntilFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00 | [optional]
 **filter_cost_center** | **string**| Query parameter to fetch jobs after his cost center | [optional]
 **sort_field** | **string**| Available sort options for the result data array. | [optional]
 **sort_order** | **string**| Describes the order for used sort fields | [optional] [default to asc]

### Return type

[**\Swagger\Client\Model\Jobs**](../Model/Jobs.md)

### Authorization

[ApiAuthKey](../../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postJob**
> \Swagger\Client\Model\InlineResponse201 postJob($body)

/jobs

Description: Resource to create a new fax job

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \Swagger\Client\Model\JobPost(); // \Swagger\Client\Model\JobPost | Describes the required request body to create a new fax job

try {
    $result = $apiInstance->postJob($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobsApi->postJob: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\JobPost**](../Model/JobPost.md)| Describes the required request body to create a new fax job |

### Return type

[**\Swagger\Client\Model\InlineResponse201**](../Model/InlineResponse201.md)

### Authorization

[ApiAuthKey](../../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

