<?php
/**
 * JobPostOptions
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Faxsuite RESTful API
 *
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.35
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * JobPostOptions Class Doc Comment
 *
 * @category Class
 * @description Describes the request body for the fax job
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class JobPostOptions implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'JobPost_options';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'title' => 'string',
'time_to_send' => '\DateTime',
'time_to_send_until' => '\DateTime',
'fax_header' => 'bool',
'fax_header_from' => 'string',
'station_id' => 'string',
'clip' => 'string',
'default_international_dialing_code' => 'string',
'cost_center' => 'string',
'save_documents' => 'bool'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'title' => null,
'time_to_send' => 'date-time',
'time_to_send_until' => 'date-time',
'fax_header' => null,
'fax_header_from' => null,
'station_id' => null,
'clip' => null,
'default_international_dialing_code' => null,
'cost_center' => null,
'save_documents' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'title' => 'title',
'time_to_send' => 'timeToSend',
'time_to_send_until' => 'timeToSendUntil',
'fax_header' => 'faxHeader',
'fax_header_from' => 'faxHeaderFrom',
'station_id' => 'stationID',
'clip' => 'clip',
'default_international_dialing_code' => 'defaultInternationalDialingCode',
'cost_center' => 'costCenter',
'save_documents' => 'saveDocuments'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'title' => 'setTitle',
'time_to_send' => 'setTimeToSend',
'time_to_send_until' => 'setTimeToSendUntil',
'fax_header' => 'setFaxHeader',
'fax_header_from' => 'setFaxHeaderFrom',
'station_id' => 'setStationId',
'clip' => 'setClip',
'default_international_dialing_code' => 'setDefaultInternationalDialingCode',
'cost_center' => 'setCostCenter',
'save_documents' => 'setSaveDocuments'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'title' => 'getTitle',
'time_to_send' => 'getTimeToSend',
'time_to_send_until' => 'getTimeToSendUntil',
'fax_header' => 'getFaxHeader',
'fax_header_from' => 'getFaxHeaderFrom',
'station_id' => 'getStationId',
'clip' => 'getClip',
'default_international_dialing_code' => 'getDefaultInternationalDialingCode',
'cost_center' => 'getCostCenter',
'save_documents' => 'getSaveDocuments'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['title'] = isset($data['title']) ? $data['title'] : null;
        $this->container['time_to_send'] = isset($data['time_to_send']) ? $data['time_to_send'] : null;
        $this->container['time_to_send_until'] = isset($data['time_to_send_until']) ? $data['time_to_send_until'] : null;
        $this->container['fax_header'] = isset($data['fax_header']) ? $data['fax_header'] : null;
        $this->container['fax_header_from'] = isset($data['fax_header_from']) ? $data['fax_header_from'] : null;
        $this->container['station_id'] = isset($data['station_id']) ? $data['station_id'] : null;
        $this->container['clip'] = isset($data['clip']) ? $data['clip'] : null;
        $this->container['default_international_dialing_code'] = isset($data['default_international_dialing_code']) ? $data['default_international_dialing_code'] : null;
        $this->container['cost_center'] = isset($data['cost_center']) ? $data['cost_center'] : null;
        $this->container['save_documents'] = isset($data['save_documents']) ? $data['save_documents'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets title
     *
     * @return string
     */
    public function getTitle()
    {
        return $this->container['title'];
    }

    /**
     * Sets title
     *
     * @param string $title Describes a title of the fax job. If not set the current date time will be used as title
     *
     * @return $this
     */
    public function setTitle($title)
    {
        $this->container['title'] = $title;

        return $this;
    }

    /**
     * Gets time_to_send
     *
     * @return \DateTime
     */
    public function getTimeToSend()
    {
        return $this->container['time_to_send'];
    }

    /**
     * Sets time_to_send
     *
     * @param \DateTime $time_to_send Describes the date the fax should be sent. The format must comply with ISO 8601 and must contain date and time. Date can not be in the past or more than 14 day into the future. If not set the current date time will be used as timeToSend
     *
     * @return $this
     */
    public function setTimeToSend($time_to_send)
    {
        $this->container['time_to_send'] = $time_to_send;

        return $this;
    }

    /**
     * Gets time_to_send_until
     *
     * @return \DateTime
     */
    public function getTimeToSendUntil()
    {
        return $this->container['time_to_send_until'];
    }

    /**
     * Sets time_to_send_until
     *
     * @param \DateTime $time_to_send_until Describes the date the fax can be sent until. The format must comply with ISO 8601 and must contain date and time. DateTime must be 5 minutes after TimeToSend. If not set the date will set to 2030-12-31
     *
     * @return $this
     */
    public function setTimeToSendUntil($time_to_send_until)
    {
        $this->container['time_to_send_until'] = $time_to_send_until;

        return $this;
    }

    /**
     * Gets fax_header
     *
     * @return bool
     */
    public function getFaxHeader()
    {
        return $this->container['fax_header'];
    }

    /**
     * Sets fax_header
     *
     * @param bool $fax_header Describes if the fax header should used or not for the fax job. If not set the value from api account will be used
     *
     * @return $this
     */
    public function setFaxHeader($fax_header)
    {
        $this->container['fax_header'] = $fax_header;

        return $this;
    }

    /**
     * Gets fax_header_from
     *
     * @return string
     */
    public function getFaxHeaderFrom()
    {
        return $this->container['fax_header_from'];
    }

    /**
     * Sets fax_header_from
     *
     * @param string $fax_header_from Describes the header part from in the fax header (if its used) of the a fax job. If not set the value from api account will be used
     *
     * @return $this
     */
    public function setFaxHeaderFrom($fax_header_from)
    {
        $this->container['fax_header_from'] = $fax_header_from;

        return $this;
    }

    /**
     * Gets station_id
     *
     * @return string
     */
    public function getStationId()
    {
        return $this->container['station_id'];
    }

    /**
     * Sets station_id
     *
     * @param string $station_id Describes the source identifier, which will be displayed during the transmission and appears on the receipt protocol. If not set the value from api account will be used
     *
     * @return $this
     */
    public function setStationId($station_id)
    {
        $this->container['station_id'] = $station_id;

        return $this;
    }

    /**
     * Gets clip
     *
     * @return string
     */
    public function getClip()
    {
        return $this->container['clip'];
    }

    /**
     * Sets clip
     *
     * @param string $clip Describes the Calling Line Identification Presentation (Clip). It is the transferred dialing number before the transmission of the fax document. If not set the value from api account will be used
     *
     * @return $this
     */
    public function setClip($clip)
    {
        $this->container['clip'] = $clip;

        return $this;
    }

    /**
     * Gets default_international_dialing_code
     *
     * @return string
     */
    public function getDefaultInternationalDialingCode()
    {
        return $this->container['default_international_dialing_code'];
    }

    /**
     * Sets default_international_dialing_code
     *
     * @param string $default_international_dialing_code Describes the default International Dialing Code which will be used for fax numbers without international area code. If not set the value from api account will be used
     *
     * @return $this
     */
    public function setDefaultInternationalDialingCode($default_international_dialing_code)
    {
        $this->container['default_international_dialing_code'] = $default_international_dialing_code;

        return $this;
    }

    /**
     * Gets cost_center
     *
     * @return string
     */
    public function getCostCenter()
    {
        return $this->container['cost_center'];
    }

    /**
     * Sets cost_center
     *
     * @param string $cost_center Describes the to used cost center for the fax job. If not set the value from api account will be used
     *
     * @return $this
     */
    public function setCostCenter($cost_center)
    {
        $this->container['cost_center'] = $cost_center;

        return $this;
    }

    /**
     * Gets save_documents
     *
     * @return bool
     */
    public function getSaveDocuments()
    {
        return $this->container['save_documents'];
    }

    /**
     * Sets save_documents
     *
     * @param bool $save_documents Describes if the uploaded template documents and resulting preview documents for the fax job should be stored or not. If not set the value from api account will be used
     *
     * @return $this
     */
    public function setSaveDocuments($save_documents)
    {
        $this->container['save_documents'] = $save_documents;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
